#
# shinGETsu - P2P anonymous BBS
#
# (c) Fuktommy <fuktommy@users.sourceforge.net>
# Released under the GNU General Public License
# $Id: SearchList.pm,v 1.1 2004/12/18 08:19:32 fuktommy Exp $
#

package Shingetsu::SearchList;
use strict;
use Shingetsu::Config;
use Shingetsu::Node;
use Shingetsu::Util;

#
# configration
#
my $searchlist = $Shingetsu::Config::search;

#
# show all nodes
#
sub list() {
	local $_;
	open IN, $searchlist or return ();
	my @node = ();
	while (<IN>) {
		chomp;
		my $n = new Shingetsu::Node($_);
		push @node, $n;
	}
	return @node;
}

#
# show randmized all nodes
#
sub all() {
	local $_;
	my @node = list();
	for (my $i=@node; $i>0; $i--) {
		my $t = int rand $i;
		($node[$i-1], $node[$t]) = ($node[$t], $node[$i-1]);
	}
	return @node;
}

#
# add node to list
# args: node
#
sub add($) {
	my($node) = @_;
	my $str = $node->toString() . "\n";
	local $_;
	unless (include($node)) {
		Shingetsu::Util::lock();
		open OUT, ">> $searchlist" or die "$searchlist: open failed. $!";
		print OUT "$str";
		close OUT;
		Shingetsu::Util::unlock();
	}
}

#
# include node
# args: node
#
sub include($) {
	my($node) = @_;
	my $str = $node->toString();
	local $_;
	my @node = list();
	if (grep $_->toString() eq $str, @node) {
		return 1;
	} else {
		return undef;
	}
}

#
# remove node from list
# args: node
#
sub remove($) {
	my($node) = @_;
	my $str = $node->toString();
	$str .= "\n";
	local $_;
	my @node;
	if (-e $searchlist) {
		open IN, $searchlist or exit;
		@node = <IN>;
		close IN;
	} else {
		return;
	}
	if (grep $_ eq "$str", @node) {
		Shingetsu::Util::lock();
		open OUT, "> $searchlist" or die "$searchlist: open failed. $!";
		foreach (@node) {
			print OUT if ($_ ne $str);
		}
		close OUT;
		Shingetsu::Util::unlock();
	}
}

1;
